using System;
using System.Collections.Generic;
using UnityEngine;

namespace Syntriax.Modules.Trigger
{
    public interface IColliderTriggerArea : ITriggerArea
    {
        /// <summary>
        /// <see cref="LayerMask"/> value for checking triggers
        /// </summary>
        LayerMask ColliderMask { get; set; }

        /// <summary>
        /// Called whenever the list of <see cref="Transform"/> changes
        /// </summary>
        /// <value>List of <see cref="Transform"/> that their colliders triggered the <see cref="IColliderTriggerArea"/></value>
        Action<List<Transform>> OnTriggeredTransformsUpdated { get; set; }

        /// <value>List of <see cref="Transform"/> that their colliders triggered the <see cref="IColliderTriggerArea"/></value>
        List<Transform> TriggeredTransforms { get; }
    }
}
